#pragma once

#include <stdbool.h>

#include <wayland-util.h>

#include <wlr/types/wlr_seat.h>

struct hikari_output_power_state {
  bool outputs_disabled;
  bool key_init;

  struct wlr_keyboard_grab_interface keyboard_grab_interface;
  struct wlr_pointer_grab_interface cursor_grab_interface;
  struct wlr_seat_keyboard_grab keyboard_grab;
  struct wlr_seat_pointer_grab cursor_grab;
};

void
hikari_output_power_state_init(
    struct hikari_output_power_state *output_power_state);

void
hikari_output_power_state_enter(void);

void
hikari_output_power_state_fini(void);

void
hikari_output_power_manager_set_mode_handler(
    struct wl_listener *listener, void *data);
